



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Kotlin入门(16)容器的遍历方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Kotlin入门(16)容器的遍历方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 22:25:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Kotlin号称全面兼容Java，于是乎Java的容器类仍可在Kotlin中正常使用，包括大家熟悉的队列ArrayList、映射HashMap等等。不过Kotlin作为一门全新的语言，肯定还是要有自己的容器类，不然哪天Java跟Kotlin划清界限，那麻烦就大了。与Java类似，Kotlin也拥有三类基本的容器，分别是集合Set、队列List、映射Map，然后每类容器又分作只读与可变两种类型，这是为了判断该容器能否进行增删改等变更操作。Kotlin对修改操作很慎重，比如变量用val前缀表示不可修改，用var前缀表示允许修改；类默认是不允许继承的，只有添加open前缀才允许该类被继承；至于容器默认为只读容器，如果需要进行修改则需加上Mutable形成新的容器，比如MutableSet表示可变集合，MutableList表示可变队列，MutableMap表示可变映射。</p>
<p>既然Set/List/Map都属于容器，那么必定拥有相同的基本容器方法，具体说明如下：<br />isEmpty : 判断该容器是否为空。<br />isNotEmpty : 判断该容器是否非空。<br />clear : 清空该容器。<br />contains : 判断该容器是否包含指定元素。<br />iterator : 获取该容器的迭代器。<br />count : 获取该容器包含的元素个数，也可通过size属性获得元素数量。<br />初始化赋值 : Kotlin允许在声明容器变量之时进行初始赋值，这点很方便比Java先进，当然不同容器的初始化方法有所区别，具体的对应关系见下表：<br />只读集合Set	setOf<br />可变集合	mutableSetOf<br />只读队列List	listOf<br />可变队列MutableList	mutableListOf<br />只读映射Map	mapOf<br />可变映射MutableMap	mutableMapOf<br />以上是Kotlin容器的基本方法，更具体的增删改查等用法则有所不同，下面分别介绍这三类六种容器的详细用法。</p>
<p><strong>只读集合Set/可变集合MutableSet</strong><br />集合是一种简单的容器，它具有以下特性：<br />1、容器内部的元素不按顺序排列，因此无法按照下标进行访问；<br />2、容器内部的元素存在唯一性，通过哈希值校验是否存在相同的元素，如果存在则覆盖之；<br />因为Set是只读集合，初始化赋值后便不可更改，所以元素变更的方法只适用于可变集合MutableSet，但MutableSet的变更操作尚有以下限制：<br />1、MutableSet的add方法仅仅往集合中添加元素，由于集合是无序的，因此不知道添加的具体位置；<br />2、MutableSet没有修改元素值的方法，一个元素一旦被添加，就不可被修改；<br />3、MutableSet的remove方法用于删除指定对象，但无法删除某个位置的元素，这是因为集合内的元素不是按顺序排列的；</p>
<p>对于集合的遍历操作，Kotlin提供了好几种方式，有熟悉的for循环，有迭代器循环，还有新面孔forEach循环，三种循环遍历的用法说明如下：</p>
<p><strong>1、for-in循环</strong><br />与Java类似，通过for语句加上in条件，即可轻轻松松依次取出集合中的所有元素。下面是运用了for-in循环的代码例子：</p>
<div>
<pre class="prettyprint linenums">    btn_set_for.setOnClickListener {<br />
        var desc = ""<br />
        //使用for-in语句循环取出集合中的每条记录<br />
        for (item in goodsMutSet) {<br />
            desc = "${desc}名称：${item.name}，价格：${item.price}\n"<br />
        }<br />
        tv_set_result.text = "手机畅销榜包含以下${goodsMutSet.size}款手机：\n$desc"<br />
    }
</pre>
</div>
<p>　　</p>
<p><strong>2、迭代器循环</strong><br />迭代器与指针的概念有点接近，它自身并非具体的元素，而是指向元素的存放地址，所以迭代器循环其实是遍历所有元素的地址。迭代器通过hasNext方法判断是否还存在下一个节点，如果不存在下一节点则表示已经遍历完毕；它通过next方法获得下一个节点的元素，同时迭代器自身改为指向该元素的地址。下面是运用了迭代器循环的代码例子：</p>
<div>
<pre class="prettyprint linenums">    btn_set_iterator.setOnClickListener {<br />
        var desc = ""<br />
        val iterator = goodsMutSet.iterator()<br />
        //如果迭代器还存在下一个节点，则继续取出下一个节点的记录<br />
        while (iterator.hasNext()) {<br />
            val item = iterator.next()<br />
            desc = "${desc}名称：${item.name}，价格：${item.price}\n"<br />
        }<br />
        tv_set_result.text = "手机畅销榜包含以下${goodsMutSet.size}款手机：\n$desc"<br />
    }
</pre>
</div>
<p>　　</p>
<p><strong>3、forEach循环</strong><br />不管是for-in循环还是迭代器循环，其实都脱胎于Java已有的容器遍历操作，代码书写上不够精炼。为了将代码精简做到极致，Kotlin给容器创造了forEach方法，明确指定该方法就是要依次遍历容器。forEach方法在编码时采用匿名函数的形式，内部使用it代表每个元素的对象，下面是运用了forEach循环的代码例子：</p>
<div>
<pre class="prettyprint linenums">    btn_set_foreach.setOnClickListener {<br />
        var desc = ""<br />
        //forEach内部使用it指代每条记录<br />
        goodsMutSet.forEach { desc = "${desc}名称：${it.name}，价格：${it.price}\n" }<br />
        tv_set_result.text = "手机畅销榜包含以下${goodsMutSet.size}款手机：\n$desc"<br />
    }
</pre>
</div>
<p>　　</p>
<p>结合以上有关Set的用法说明，我们发现集合在实战中存在诸多不足，主要包括以下几点：<br />1、集合不允许修改内部元素的值；<br />2、集合无法删除指定位置的元素；<br />3、不能通过下标获取指定位置的元素；<br />鉴于集合的以上缺点难以克服，故而实际开发基本用不到集合，大多数场合用的是它的两个兄弟&mdash;&mdash;队列和映射。</p>
<p><strong>只读队列List/可变队列MutableList</strong><br />队列是一种元素之间按照顺序排列的容器，它与集合的最大区别，便是多了个次序管理。不要小看这个有序性，正因为队列建立了秩序规则，所以它比集合多提供了如下功能（注意凡是涉及到增删改的，都必须由MutableList来完成）：<br />1、队列的get方法能够获取指定位置的元素，也可直接通过下标获得该位置的元素。<br />2、MutableList的add方法每次都是把元素添加到队列末尾，也可指定添加的位置；<br />3、MutableList的set方法允许替换或者修改指定位置的元素；<br />4、MutableList的removeAt方法允许删除指定位置的元素；<br />5、MutableList提供了sort系列方法用于给队列中的元素重新排序，其中sortBy方法表示按照升序排列，sortByDescending方法表示按照降序排列；下面是个给队列排序的代码例子：</p>
<div>
<pre class="prettyprint linenums">    var sortAsc = true<br />
    btn_sort_by.setOnClickListener {<br />
        if (sortAsc) {<br />
            //sortBy表示升序排列，后面跟的是排序条件<br />
            goodsMutList.sortBy { it.price }<br />
        } else {<br />
            //sortByDescending表示降序排列，后面跟的是排序条件<br />
            goodsMutList.sortByDescending { it.price }<br />
        }<br />
        var desc = ""<br />
        for (item in goodsMutList) {<br />
            desc = "${desc}名称：${item.name}，价格：${item.price}\n"<br />
        }<br />
        tv_list_result.text = "手机畅销榜已按照${if (sortAsc) "升序" else "降序"}重新排列：\n$desc"<br />
        sortAsc = !sortAsc<br />
    }
</pre>
</div>
<p>　　</p>
<p>5、队列除了拥有跟集合一样的三种遍历方式（for-in循环、迭代器循环、forEach循环），另外多了一种按元素下标循环遍历的方式，具体下标遍历的代码例子如下所示：</p>
<div>
<pre class="prettyprint linenums">    btn_for_index.setOnClickListener {<br />
        var desc = ""<br />
        //indices是队列的下标数组。如果队列大小为10，则下标数组的取值为0到9<br />
        for (i in goodsMutList.indices) {<br />
            val item = goodsMutList[i]<br />
            desc = "${desc}名称：${item.name}，价格：${item.price}\n"<br />
        }<br />
        tv_list_result.text = "手机畅销榜包含以下${goodsMutList.size}款手机：\n$desc"<br />
    }
</pre>
</div>
<p>　　</p>
<p><strong>只读映射Map/可变映射MutableMap</strong><br />映射内部保存的是一组键值对（Key-Value），也就是说，每个元素都由两部分构成，第一部分是元素的键，相当于元素的名字；第二部分是元素的值，存放着元素的详细信息。元素的键与值是一一对应的关系，相同的键名指向的值对象是唯一的，所以映射中每个元素的键名各不相同，这个特性使得映射的变更操作与队列存在以下不同之处（注意增删操作必须由MutableMap来完成）：<br />1、映射的containsKey方法判断是否存在指定键名的元素，containsValue方法判断是否存在指定值对象的元素；<br />2、MutableMap的put方法不单单是添加元素，而是智能的数据存储；每次调用put方法，映射会先根据键名寻找同名元素，如果找不到就添加新元素，如果找得到就用新元素替换旧元素；<br />3、MutableMap的remove方法，是通过键名来删除元素的；<br />4、调用mapOf和mutableMapOf方法初始化映射之时，有两种方式可以表达单个键值对元素。其一是采取&ldquo;键名 to 值对象&rdquo;的形式，其二是采取Pair配对方式形如&ldquo;Pair(键名, 值对象)&rdquo;，下面是这两种初始化方式的代码例子：</p>
<div>
<pre class="prettyprint linenums">//to方式初始化映射<br />
var goodsMap = mapOf("苹果" to goodsA, "华为" to goodsB, "小米" to goodsC, "欧珀" to goodsD, "步步高" to goodsE, "魅族" to goodsF)<br />
//Pair方式初始化映射<br />
var goodsMutMap = mutableMapOf(Pair("苹果", goodsA), Pair("华为", goodsB), Pair("小米", goodsC), Pair("欧珀", goodsD), Pair("步步高", goodsE), Pair("魅族", goodsF))
</pre>
</div>
<p>　　</p>
<p>映射的遍历与集合类似，也有for-in循环、迭代器循环、forEach循环三种遍历手段。但是由于映射的元素是个键值对，因此它的循环遍历方式与集合稍有不同，详述如下：<br /><strong>1、for-in循环</strong><br />for-in语句取出来的是映射的键值对元素，若要获取该元素的键名，还需访问元素的key属性；若要获取该元素的值对象，还需访问元素的value属性。下面是在映射中运用for-in循环的代码例子：</p>
<div>
<pre class="prettyprint linenums">    btn_map_for.setOnClickListener {<br />
        var desc = ""<br />
        //使用for-in语句循环取出映射中的每条记录<br />
        for (item in goodsMutMap) {<br />
            //item.key表示该配对的键，即厂家名称；item.value表示该配对的值，即手机信息<br />
            desc = "${desc}厂家：${item.key}，名称：${item.value.name}，价格：${item.value.price}\n"<br />
        }<br />
        tv_map_result.text = "手机畅销榜包含以下${goodsMutMap.size}款手机：\n$desc"<br />
    }
</pre>
</div>
<p>　　</p>
<p><strong>2、迭代器循环</strong><br />映射的迭代器通过next函数得到下一个元素，也需访问该元素的key属性获取键名，访问该元素的value属性获取值对象。下面是在映射中运用迭代器循环的代码例子：</p>
<div>
<pre class="prettyprint linenums">    btn_map_iterator.setOnClickListener {<br />
        var desc = ""<br />
        val iterator = goodsMutMap.entries.iterator()<br />
        //如果迭代器还存在下一个节点，则继续取出下一个节点的记录<br />
        while (iterator.hasNext()) {<br />
            val item = iterator.next()<br />
            desc = "${desc}厂家：${item.key}，名称：${item.value.name}，价格：${item.value.price}\n"<br />
        }<br />
        tv_map_result.text = "手机畅销榜包含以下${goodsMutMap.size}款手机：\n$desc"<br />
    }
</pre>
</div>
<p>　　</p>
<p><strong>3、forEach循环</strong><br />映射的forEach方法内部依旧采用匿名函数的形式，同时把元素的key和value作为匿名函数的输入参数。不过映射的forEach函数需要API24及以上版本支持，开发时注意修改编译配置。下面是在映射中运用forEach循环的代码例子：</p>
<div>
<pre class="prettyprint linenums">    btn_map_foreach.setOnClickListener {<br />
        //var desc = ""<br />
        ////映射的forEach函数需要API24及以上版本支持<br />
        ////forEach内部使用key指代每条记录的键，使用value指代每条记录的值<br />
        //goodsMap.forEach { key, value -&gt; desc = "${desc}厂家：${key}，名称：${value.name}，价格：${value.price}\n" }<br />
        //tv_map_result.text = "手机畅销榜包含以下${goodsMutMap.size}款手机：\n$desc"<br />
        tv_map_result.text = "Map的forEach函数需要API24及以上版本支持"<br />
    }
</pre>
</div>
<p>　　</p>
<p>__________________________________________________________________________</p>
<p>打开微信扫一扫下面的二维码，或者直接搜索公众号&ldquo;老欧说安卓&rdquo;添加关注，更快更方便地阅读技术干货。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/729938/201708/729938-20170822094958261-1620257166.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390ro649.html">ubuntu 12&period;04 LTS 如何使用更快的更新源</a>
		</li>
						<li><a href="https://www.batexi.com/a/3902zg4q.html">最简单jquery轮播图效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq151w29.html">js获取&quest;后面具体参数的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kv2m59.html">js判断手机系统是iOS还是android</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlee29.html">angularjs之&dollar;timeout指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/390n1mnq.html">ThinkPHP函数详解：F方法（快速缓存方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvy15yq.html">53&period; Minimum Window Substring</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1gxw4q.html">zt&colon;如何快速赚取人生第一个100万？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k11nm39.html">poj2354Titanic&lpar;两点的球面距离&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xj4or9.html">设备模型之kobject&comma;kset及其关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oloxv9.html">ASP&period;NET MVC 下载列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm66le9.html">DFS的基础训练清单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjm7m38.html">Surface，送我都不要</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mer16oq.html">从今天起开始记录下在freecodecamp学习的一些tip吧（所有内容都在这个随笔的评论里面记录）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m1ep38.html">jmeter的使用---web测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvdrxx8.html">纪中2018暑假培训day5提高b组改题记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lo6v9.html">android ------- 开发者的 RxJava 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ex5pg9.html">Linux内核分析：完成一个简单的时间片轮转多道程序内核代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v4x60q.html">OS之进程管理---进程调度和多线程调度</a>
		</li>
						<li><a href="https://www.batexi.com/a/902kwroq.html">&lbrack;微软官方&rsqb;FSUTIL</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnv47m28.html">关于hermes与solr，es的定位与区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rkzo39.html">注意：Tomcat Get请求的坑！</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j3xynq.html">&lbrack;原&rsqb;Windows Azure开发之Linux虚拟机</a>
			</li>
						<li><a href="https://www.batexi.com/a/960z1z49.html">10-部署配置dashboard插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv23xm19.html">code128 C语言实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25y7jvq.html">gitlab服务部署及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g75dmq.html">测试工具之Jmeter（使用badboy录制脚本）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4x1oe9.html">等宽高的ImageButton</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zylr4n9.html">图片上传预览js</a>
			</li>
						<li><a href="https://www.batexi.com/a/96047g39.html">IE8浏览器官方下载 包含Windows中繁英文各个版本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
